<?php



/**

 * The plugin bootstrap file

 *

 * This file is read by WordPress to generate the plugin information in the plugin

 * admin area. This file also includes all of the dependencies used by the plugin,

 * registers the activation and deactivation functions, and defines a function

 * that starts the plugin.

 *

 * @link              

 * @since             1.0.0

 * @package           Easy_Multi_Step_Form

 *

 * @wordpress-plugin

 * Plugin Name:       Easy Multi Step Form

 * Plugin URI:        https://www.witoni.com
 
 * Author URI:        https://www.witoni.com

 * Description:       Create Multi Step Email Form Using Drag & Drop Builder Easily.

 * Version:           1.0.0

 * Author:            Witoni Softwares

 * License:           GPL-2.0+

 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt

 * Text Domain:       easy_multi_step_form

 * Domain Path:       /languages

 */



// If this file is called directly, abort.

if ( ! defined( 'WPINC' ) ) {

	die;

}



/**

 * The code that runs during plugin activation.

 * This action is documented in includes/class-multi_step_reg-activator.php

 */

function activate_multi_step_reg() {

	require_once plugin_dir_path( __FILE__ ) . 'includes/class-multi_step_reg-activator.php';

	Multi_step_reg_Activator::activate();

}



/**

 * The code that runs during plugin deactivation.

 * This action is documented in includes/class-multi_step_reg-deactivator.php

 */

function deactivate_multi_step_reg() {

	require_once plugin_dir_path( __FILE__ ) . 'includes/class-multi_step_reg-deactivator.php';

	Multi_step_reg_Deactivator::deactivate();

}



register_activation_hook( __FILE__, 'activate_multi_step_reg' );

register_deactivation_hook( __FILE__, 'deactivate_multi_step_reg' );



/**

 * The core plugin class that is used to define internationalization,

 * admin-specific hooks, and public-facing site hooks.

 */

require plugin_dir_path( __FILE__ ) . 'includes/class-multi_step_reg.php';



/**

 * Begins execution of the plugin.

 *

 * Since everything within the plugin is registered via hooks,

 * then kicking off the plugin from this point in the file does

 * not affect the page life cycle.

 *

 * @since    1.0.0

 */

function run_multi_step_reg() {



	$plugin = new Multi_step_reg();

	$plugin->run();



}

run_multi_step_reg();

